<?php
####################################################################
# OpenGlobal Cookie Law Tool plugin                                #
# Copyright (C) 2012 OpenGlobal E-commerce                         #
# Homepage   : www.openglobal.co.uk                                #
# Author     : OpenGlobal E-commerce                               #
# Version    : 1.0                                                 #
# Created Date  : 2013-08-04                                       #
# License    : GNU/GPLv3                                           #
####################################################################

/**
 * This plugin is licensed under the GNU/GPLv3 licence, and as such you may modify this plugin however you wish,
 * but the link to the OpenGlobal E-commerce website in the resulting tool must remain as it is here
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');

class plgSystemOpenGlobalCookieLawTool extends JPlugin
{
	function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	function onAfterRender() {
		$mainframe = JFactory::getApplication();
		if (!$mainframe->isAdmin()) {
			$page = JResponse::getBody();

			$cookieLawTool = $this->getCookieLawTool($this->params->def('privacy_policy_page'), $this->params->def('leave_url'), $this->params->def('timeout'), $this->params->def('functions'));
			$page = preg_replace('/(<body([^>]*)>)/', "$1".$cookieLawTool, $page);

			JResponse::setBody($page);
		}
		return true;
	}

	function getCookieLawTool($privacyPolicyPage, $leave_url = 'http://www.change.org/petitions/stop-the-eu-s-legal-war-on-web-cookies', $timeout = 0, $functions = '') {
		$isHtml5 = $this->params->get('html5', 0);
		$lang = JFactory::getLanguage();
		$lang->load('plg_system_openglobalcookielawtool', JPATH_ADMINISTRATOR, $lang->getTag(), true);

		return
'<!-- Copyright (c) OpenGlobal. GNU/GPL V3 licence. You may copy and modify this, providing the link to http://www.openglobal.co.uk remains intact. -->
<div id="openglobal_privacy_widget" style="display: inline; text-align:right; font-size: 13px; line-height: 100%; position: fixed; top: 0; right: 0; margin: 0; padding: 0 0 0 3px; background: #dddddd; z-index: 100000; opacity:0.9; filter: alpha(opacity=90);">
'.JText::_('PLG_SYSTEM_OGCOOKIELAWTOOL_ACCEPT').' <a title="'.JText::_('PLG_SYSTEM_OGCOOKIELAWTOOL_EXPLANATION').'" '.($isHtml5 ? 'data-' : '').'rel="privacy" href="'.$privacyPolicyPage.'">'.JText::_('PLG_SYSTEM_OGCOOKIELAWTOOL_COOKIES').'</a>?
<button id="openglobal_privacy_accept" style="vertical-align: middle;" onclick="openglobal_privacy_accept();return false;">'.JText::_('PLG_SYSTEM_OGCOOKIELAWTOOL_YES').'</button>
<button id="openglobal_privacy_wait" style="vertical-align: middle;" onclick="clearTimeout(openglobal_privacy_timer);return false;">'.JText::_('PLG_SYSTEM_OGCOOKIELAWTOOL_WAIT').'</button>
<button id="openglobal_privacy_leave" style="vertical-align: middle;" onclick="window.location=\''.$leave_url.'\';">'.JText::_('PLG_SYSTEM_OGCOOKIELAWTOOL_LEAVE').'</button>
<br />
<span style="font-size: 9px">Provided by <a href="http://www.openglobal.co.uk" title="OpenGlobal e-commerce web design and promotion">OpenGlobal E-commerce</a></span>
</div>
<script type="text/javascript">
//<![CDATA[
var openglobal_privacy_timeout = '.$timeout.';
var openglobal_privacy_functions = ['.$functions.'];

var openglobal_privacy_widget = document.getElementById(\'openglobal_privacy_widget\');
var results = document.cookie.match ( \'(^|;) ?openglobal_privacy_widget=([^;]*)(;|$)\' );
if (results) {
  if (1 == unescape(results[2])) {
    openglobal_privacy_accept();
  }
} else {
  window.onload = function() {
    for (var i = 0; i < document.links.length; i++) {
      var link_href = document.links[i].getAttribute(\'href\');
      if (\'privacy\' != document.links[i].getAttribute(\''.($isHtml5 ? 'data-' : '').'rel\') && (!/^[\w]+:/.test(link_href) || (new RegExp(\'^[\\\\\\w]+://[\\\\\\w\\\\\\d\\\\\\-\\\\\\.]*\' + window.location.host)).test(link_href))) {
        var current_onclick = document.links[i].onclick;
document.links[i].onclick = function() {openglobal_privacy_accept();if (Object.prototype.toString.call(current_onclick) == \'[object Function]\') {current_onclick();}};
      }
    }
  };
}

var openglobal_privacy_timer;
if (openglobal_privacy_timeout > 0) {
   openglobal_privacy_timer = setTimeout(\'openglobal_privacy_tick()\', 1000);
} else {
  var openglobal_privacy_wait = document.getElementById(\'openglobal_privacy_wait\');
  if (null != openglobal_privacy_wait) {
    openglobal_privacy_wait.parentNode.removeChild(openglobal_privacy_wait);
  }
}
function openglobal_privacy_tick() {
  if (0 >= --openglobal_privacy_timeout) {
    openglobal_privacy_accept();
    return;
  }
  var openglobal_privacy_accept_button = document.getElementById(\'openglobal_privacy_accept\');
  if (null != openglobal_privacy_accept_button) {
    openglobal_privacy_accept_button.innerHTML = \'Yes (\' + openglobal_privacy_timeout + \')\';
    openglobal_privacy_timer = setTimeout(\'openglobal_privacy_tick()\', 1000);
  }
}

function openglobal_privacy_accept() {
  clearTimeout(openglobal_privacy_timer);
  document.cookie = \'openglobal_privacy_widget=1; path=/; expires=Mon, 18 Jan 2038 03:14:00 GMT\';
  openglobal_privacy_widget.parentNode.removeChild(openglobal_privacy_widget);
  for (var i = 0; i < openglobal_privacy_functions.length; i++) {
    openglobal_privacy_functions[i]();
  }
}
//]]>
</script>';
	}
}
?>
